import { SvelteComponent, init, safe_not_equal, append_styles, create_slot, element, attr, null_to_empty, insert, update_slot_base, get_all_dirty_from_scope, get_slot_changes, transition_in, transition_out, detach } from 'svelte/internal';
import { onDestroy } from 'svelte';
import { writable } from 'svelte/store';

const columnsStore = writable(12);

/* src/lib/Grid.svelte generated by Svelte v3.42.1 */

function add_css(target) {
	append_styles(target, "svelte-lwwtah", ".containerSGR.svelte-lwwtah{box-sizing:border-box;display:flex;flex-wrap:wrap;width:calc(100% + (var(--paddingSGR) * 2));margin:var(--marginSGR)}.colSGR.svelte-lwwtah{position:relative;box-sizing:border-box;flex-grow:var(--colFlexSGR);padding:var(--paddingSGR);order:var(--orderSGR)}.col-xs.svelte-lwwtah{flex-basis:var(--xsWidthSGR);max-width:var(--xsWidthSGR)}@media(min-width: 576px){.col-sm.svelte-lwwtah{flex-basis:var(--smWidthSGR);max-width:var(--smWidthSGR)}}@media(min-width: 768px){.col-md.svelte-lwwtah{flex-basis:var(--mdWidthSGR);max-width:var(--mdWidthSGR)}}@media(min-width: 992px){.col-lg.svelte-lwwtah{flex-basis:var(--lgWidthSGR);max-width:var(--lgWidthSGR)}}@media(min-width: 1200px){.col-xl.svelte-lwwtah{max-width:var(--xlWidthSGR)}}");
}

function create_fragment(ctx) {
	let div;
	let div_class_value;
	let current;
	const default_slot_template = /*#slots*/ ctx[12].default;
	const default_slot = create_slot(default_slot_template, ctx, /*$$scope*/ ctx[11], null);

	return {
		c() {
			div = element("div");
			if (default_slot) default_slot.c();
			attr(div, "style", /*styleGeneral*/ ctx[1]);
			attr(div, "class", div_class_value = "" + (null_to_empty(/*classGeneral*/ ctx[0]) + " svelte-lwwtah"));
		},
		m(target, anchor) {
			insert(target, div, anchor);

			if (default_slot) {
				default_slot.m(div, null);
			}

			current = true;
		},
		p(ctx, [dirty]) {
			if (default_slot) {
				if (default_slot.p && (!current || dirty & /*$$scope*/ 2048)) {
					update_slot_base(
						default_slot,
						default_slot_template,
						ctx,
						/*$$scope*/ ctx[11],
						!current
						? get_all_dirty_from_scope(/*$$scope*/ ctx[11])
						: get_slot_changes(default_slot_template, /*$$scope*/ ctx[11], dirty, null),
						null
					);
				}
			}

			if (!current || dirty & /*styleGeneral*/ 2) {
				attr(div, "style", /*styleGeneral*/ ctx[1]);
			}

			if (!current || dirty & /*classGeneral*/ 1 && div_class_value !== (div_class_value = "" + (null_to_empty(/*classGeneral*/ ctx[0]) + " svelte-lwwtah"))) {
				attr(div, "class", div_class_value);
			}
		},
		i(local) {
			if (current) return;
			transition_in(default_slot, local);
			current = true;
		},
		o(local) {
			transition_out(default_slot, local);
			current = false;
		},
		d(detaching) {
			if (detaching) detach(div);
			if (default_slot) default_slot.d(detaching);
		}
	};
}

function instance($$self, $$props, $$invalidate) {
	let { $$slots: slots = {}, $$scope } = $$props;
	let { container = false } = $$props;
	let { columns = 12 } = $$props;
	let { gutter = false } = $$props;
	let { xs = false } = $$props;
	let { sm = false } = $$props;
	let { md = false } = $$props;
	let { lg = false } = $$props;
	let { xl = false } = $$props;
	let { order = false } = $$props;
	let classGeneral = '';
	let styleGeneral = '';
	let localColumns;
	const unsubscribe = columnsStore.subscribe(value => localColumns = value);

	const getValue = breakpoint => {
		if (breakpoint > localColumns) {
			breakpoint = localColumns;
		}

		return breakpoint
		? `${breakpoint / localColumns * 100}%`
		: false;
	};

	const createClassSize = () => {
		let newClass = 'col-xs ';
		newClass += sm ? 'col-sm ' : '';
		newClass += md ? 'col-md ' : '';
		newClass += lg ? 'col-lg ' : '';
		newClass += xl ? 'col-xl ' : '';
		return newClass;
	};

	const createStyleSize = () => {
		let newStyle = '';

		newStyle += xs
		? `--xsWidthSGR:${getValue(xs)}; `
		: `--xsWidthSGR:100%; `;

		newStyle += sm ? `--smWidthSGR:${getValue(sm)}; ` : '';
		newStyle += md ? `--mdWidthSGR:${getValue(md)}; ` : '';
		newStyle += lg ? `--lgWidthSGR:${getValue(lg)}; ` : '';
		newStyle += xl ? `--xlWidthSGR:${getValue(xl)}; ` : '';
		return newStyle;
	};

	const createGutter = () => {
		return gutter
		? `--paddingSGR:${gutter / 2}px;--marginSGR:-${gutter / 2}px`
		: '--paddingSGR:0px;--marginSGR:0px';
	};

	onDestroy(() => unsubscribe());

	$$self.$$set = $$props => {
		if ('container' in $$props) $$invalidate(2, container = $$props.container);
		if ('columns' in $$props) $$invalidate(3, columns = $$props.columns);
		if ('gutter' in $$props) $$invalidate(4, gutter = $$props.gutter);
		if ('xs' in $$props) $$invalidate(5, xs = $$props.xs);
		if ('sm' in $$props) $$invalidate(6, sm = $$props.sm);
		if ('md' in $$props) $$invalidate(7, md = $$props.md);
		if ('lg' in $$props) $$invalidate(8, lg = $$props.lg);
		if ('xl' in $$props) $$invalidate(9, xl = $$props.xl);
		if ('order' in $$props) $$invalidate(10, order = $$props.order);
		if ('$$scope' in $$props) $$invalidate(11, $$scope = $$props.$$scope);
	};

	$$self.$$.update = () => {
		if ($$self.$$.dirty & /*container, columns, xs, sm, md, lg, xl, styleGeneral, order*/ 2030) {
			{
				$$invalidate(0, classGeneral = container
				? 'containerSGR'
				: `colSGR ${createClassSize()}`);

				if (container) {
					$$invalidate(1, styleGeneral = createGutter());
					columnsStore.update(() => columns);
				} else {
					$$invalidate(1, styleGeneral = createStyleSize());

					if (xs || sm || md || lg || xl) {
						$$invalidate(1, styleGeneral += `--colFlexSGR:0;`);
					} else {
						$$invalidate(1, styleGeneral = `--colFlexSGR:1;`);
					}

					if (order || order === 0) {
						$$invalidate(1, styleGeneral += `--orderSGR:${order};`);
					}
				}
			}
		}
	};

	return [
		classGeneral,
		styleGeneral,
		container,
		columns,
		gutter,
		xs,
		sm,
		md,
		lg,
		xl,
		order,
		$$scope,
		slots
	];
}

class Grid extends SvelteComponent {
	constructor(options) {
		super();

		init(
			this,
			options,
			instance,
			create_fragment,
			safe_not_equal,
			{
				container: 2,
				columns: 3,
				gutter: 4,
				xs: 5,
				sm: 6,
				md: 7,
				lg: 8,
				xl: 9,
				order: 10
			},
			add_css
		);
	}
}

export { Grid as default };
